%define debug_package %{nil}

Name:    cadvisor
Version: 0.37.0
Release: 5
Summary: Analyzes resource usage and performance characteristics of running containers.
License: ASL 2.0
URL:     https://github.com/google/cadvisor

Source0: https://github.com/google/cadvisor/archive/v%{version}.tar.gz
Source1: vendor.tar.gz
#source2 version sys@v0.0.0-20220908164124-27713097b956
Source2: sys.tar.gz
Patch0:  use_preinstalled_go-bindata.patch
Patch1:  add-parameters-to-solve-the-strip.patch
Patch2:  Add-loong64-support-for-runc-procfs-and-crc32.patch
Patch1000:  1000-add-riscv64-support-for-crc32-and-procfs.patch

BuildRequires: golang >= 1.13

Conflicts: cadvisor
Provides:  %{name} = %{version}

%description
cAdvisor (Container Advisor) provides container users an understanding of the resource
usage and performance characteristics of their running containers. 
It is a running daemon that collects, aggregates, processes, and
exports information about running containers. Specifically, for
each container it keeps resource isolation parameters, historical
resource usage, histograms of complete historical resource usage
and network statistics. This data is exported by container and machine-wide.


%prep
%setup -q -T -n %{name}-%{version} -b 0 -b 1
%patch0 -p1
%patch1 -p1
%patch2 -p1
%ifarch loongarch64
rm -rf vendor/golang.org/x/sys
rm -rf cmd/vendor/golang.org/x/sys/
tar -xf %{SOURCE2} -C vendor/golang.org/x/
tar -xf %{SOURCE2} -C cmd/vendor/golang.org/x/
%endif
%ifarch riscv64
%patch1000 -p1
%endif

%build
export GOFLAGS="-mod=vendor -buildmode=pie"
make build

%install
install -D -m 755 cadvisor %{buildroot}%{_bindir}/cadvisor


%files
%defattr(-,root,root,-)
%{_bindir}/cadvisor


%changelog
* Thu Aug 31 2023 misaka00251 <liuxin@iscas.ac.cn> - 0.37.0-5
- Add riscv64 support

* Tue Jul 11 2023 huajingyun <huajingyun@loongson.cn> - 0.37.0-4
- Add loong64 support

* Tue Mar 07 2023 jiangxinyu <jiangxinyu@kylinos.cn> - 0.37.0-3
- Add strip and pie

* Fri Jul 22 2022 wo_cow <niuqianqian@huawei.com> - 0.37.0-2
- Fix build err: nothing provides go-bindata

* Tue Dec 15 2020 yangzhao <yangzhao1@kylinos.cn> - 0.37.0-1
- Init project cadvisor
